! This program is meant to show the SSCANF
! system subroutine.
! The format string claims that a byte, an octal,
! a four byte string, a decimal and a string
! can be expected. In the read string all those
! elements can be found.
! The arguments are pushed in reverse order as usual.
! before the call is made.
! Note that the end of line is not processed in the
! string request %s.
! Note also that the request for the charer string is
! %4c, which can take the four characters and does not 
! need a place for the closing ascii-0

#include "../syscalnr.h"		
	_STDOUT	= 1
.SECT .TEXT				
start:	
	PUSH lstr			
	PUSH deccer			
	PUSH charer			
	PUSH byter			
	PUSH formatter			
	PUSH readstr			
	PUSH _SSCANF			
	SYS				!  mette il AL il numero di elementi letti
	CMP AX,4			! controllo il numero di elementi letti
	JE   1f
stampaerr:
	MOV	CX,finemsgerr-msgerr
	PUSH	CX
	PUSH	msgerr
	PUSH	_STDOUT
	PUSH	_WRITE
	SYS	
	ADD	SP,8
!sscanf ok
1:	ADD SP,14
	PUSH 0	
	PUSH _EXIT
	SYS	
.SECT .DATA				
fmt: .ASCIZ "%o"		
str: .ASCIZ "0123"		
formatter: .ASCIZ "%c %4c %d %s"
readstr: .ASCIZ "A ball 997 cq\n"  ! stringa giusta
!readstr: .ASCIZ "A ball cq\n"     ! stringa sbagliata, manca il numero decimale
.ALIGN 2		
.SECT .BSS				
lstr: .SPACE 4			
deccer: .SPACE 2		
charer: .SPACE 4		
byter:  .SPACE 1		
msgerr: .ASCII	"ERRORE\n"	
finemsgerr: .BYTE	0
